/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.DatabankActions;

import java.util.ArrayList;

import javax.swing.JOptionPane;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.strategyquant.lib.app.MainApp;
import com.strategyquant.lib.computers.PortfolioComputer;
import com.strategyquant.lib.databank.Databank;
import com.strategyquant.lib.databank.DatabankAction;
import com.strategyquant.lib.databank.DatabanksRegistry;
import com.strategyquant.lib.language.L;
import com.strategyquant.lib.plugins.SQGlobalEventMsg;
import com.strategyquant.lib.plugins.SQGlobalEvents;
import com.strategyquant.lib.results.SQResultsGroup;
import com.strategyquant.lib.settings.SQCoreConst;

public class CreatePortfolio extends DatabankAction {
	public static final Logger Log = LoggerFactory.getLogger("CreatePortfolio");
	public PortfolioComputer portfolioComputer = new PortfolioComputer();
	
	public CreatePortfolio() {
		setName(L.t("Create Portfolio"));
	}
	
	@Override
	public void execute(Databank databank) {
		ArrayList<SQResultsGroup> results = databank.getSelectedResults();
		
		if(results.size()<2) {
        	JOptionPane.showMessageDialog(MainApp.getFrame(),
        			L.t("You have to select at least 2 strategies to create portfolio."),
        			L.t("Create Portfolio error"),
        		    JOptionPane.ERROR_MESSAGE);
        	return;			
		}
		
		try {
			SQResultsGroup portfolioResults = portfolioComputer.createPortfolio(results, "Portfolio");
			
			DatabanksRegistry.get(SQCoreConst.EAA_DATABANK_PORTFOLIOS).add(portfolioResults);

			SQGlobalEvents.getInstance().callChangeEvent(SQGlobalEventMsg.EAA_SELECT_DATABANK, SQCoreConst.EAA_DATABANK_PORTFOLIOS);			
		} catch(Exception e) {
			Log.error("Exc.", e);
			
        	JOptionPane.showMessageDialog(MainApp.getFrame(),
        			L.t("An error has occurred while creating the portfolio.")+"\n"+
        			e.getMessage(),
        			L.t("Create Portfolio error"),
        		    JOptionPane.ERROR_MESSAGE);
        	
        	return;		
		}
	}
	
	@Override
	public String[] getAllowedDatabanks() {
		return new String[]{"*", SQCoreConst.EAA_DATABANK_PORTFOLIOS+','+SQCoreConst.MM_SIM_DATABANK};
	}
	

	@Override
	public String getProduct() {
		return SQCoreConst.PRODUCT_ANY;
	}
	
	@Override
	public int getPreferredPosition() {
		return 12;
	}
}